## vdev 0.1.2

=== Makefile ===
include buildconf.mk

.PHONY: all
all:
	$(MAKE) -C vdevd
	$(MAKE) -C libudev-compat
#	$(MAKE) -C fs
	$(MAKE) -C vdev-initramfs
	$(MAKE) -C hwdb

.PHONY: install
install:
	$(MAKE) -C vdevd install
	$(MAKE) -C libudev-compat install
#	$(MAKE) -C fs install
	$(MAKE) -C vdev-initramfs install
	$(MAKE) -C hwdb install

.PHONY: clean
clean:
	$(MAKE) -C vdevd clean
	$(MAKE) -C libudev-compat clean
#	$(MAKE) -C fs clean
	$(MAKE) -C vdev-initramfs clean
	$(MAKE) -C hwdb clean

.PHONY: uninstall
uninstall:
	$(MAKE) -C vdevd uninstall
	$(MAKE) -C libudev-compat uninstall
#	$(MAKE) -C fs uninstall
	$(MAKE) -C vdev-initramfs uninstall
	$(MAKE) -C hwdb uninstall

.PHONY: deb jail
deb:
	make -f debian.mk

jail:
	firejail --overlay make -f debian.mk

=== libudev-compat/Makefile ===
include ../buildconf.mk

CFLAGS := -Wall -g -fPIC -fstack-protector -fstack-protector-all -pthread -Wno-unused-variable -Wno-unused-but-set-variable
INC := $(INC) -I$(BUILD_LIBUDEV_COMPAT_HEADERS)
DEFS := $(DEFS) -D_POSIX_C_SOURCE=200809L -D_BSD_SOURCE -D_GNU_SOURCE
CC   := cc

C_SRCS:= $(wildcard *.c)
SYM_SRCS:= $(wildcard *.sym)

HEADERS := $(wildcard *.h)
OBJ := $(patsubst %.c,$(BUILD_LIBUDEV_COMPAT)/%.o,$(C_SRCS))
OBJ_TEST := $(filter-out $(BUILD_LIBUDEV_COMPAT)/libudev-fs.o,$(OBJ))
SYM_BUILD := $(patsubst %.sym,$(BUILD_LIBUDEV_COMPAT)/%.sym,$(SYM_SRCS))
LIB :=

VERSION_MAJOR := 1
VERSION_MINOR := 5
VERSION_PATCH := 2
VERSION := $(VERSION_MAJOR).$(VERSION_MINOR).$(VERSION_PATCH)

LIBUDEV_COMPAT := $(BUILD_LIBUDEV_COMPAT)/libudev.so.$(VERSION_MAJOR)
LIBUDEV_COMPAT_SONAME := libudev.so.$(VERSION_MAJOR)
LIBUDEV_COMPAT_LIB := $(BUILD_LIBUDEV_COMPAT)/libudev.so.$(VERSION)

LIBUDEV_COMPAT_FILES := $(LIBUDEV_COMPAT_LIB)

LIBUDEV_COMPAT_HEADERS := $(patsubst %.h,$(BUILD_LIBUDEV_COMPAT_HEADERS)/%.h,$(HEADERS))

# NOTE: only install libudev.h
LIBUDEV_COMPAT_INSTALL_HEADERS := $(BUILD_LIBUDEV_COMPAT_HEADERS)/libudev.h

LIBUDEV_COMPAT_FILES_INSTALL := $(patsubst $(BUILD_LIBUDEV_COMPAT)/%,$(INSTALL_LIBUDEV_COMPAT)/%,$(LIBUDEV_COMPAT_FILES))

LIBUDEV_COMPAT_HEADERS_INSTALL := $(patsubst $(BUILD_LIBUDEV_COMPAT_HEADERS)/%.h,$(INSTALL_LIBUDEV_COMPAT_HEADERS)/%.h,$(LIBUDEV_COMPAT_INSTALL_HEADERS))

LIBUDEV_COMPAT_PC_IN := libudev.pc.in
BUILD_LIBUDEV_COMPAT_PC := $(BUILD_PKGCONFIG)/libudev.pc
INSTALL_LIBUDEV_COMPAT_PC := $(DESTDIR)$(PKGCONFIG)/libudev.pc

all: $(LIBUDEV_COMPAT_FILES) $(LIBUDEV_COMPAT_HEADERS) $(BUILD_LIBUDEV_COMPAT_PC)

test: $(BUILD_LIBUDEV_COMPAT)/libudev-fs

$(LIBUDEV_COMPAT_LIB): $(OBJ) $(SYM_BUILD)
	@mkdir -p "$(shell dirname "$@")"
	$(CC) $(CFLAGS) $(INC) $(DEFS) -shared -Wl,--version-script=libudev.sym,-soname,$(LIBUDEV_COMPAT_SONAME) -o "$@" $(OBJ) $(LIBINC) $(LIB)

#$(LIBUDEV_COMPAT): $(LIBUDEV_COMPAT_LIB)
#	@mkdir -p "$(shell dirname "$@")"
#	@ln -sfT "$(shell basename "$<")" "$@"

$(BUILD_LIBUDEV_COMPAT)/libudev-fs: $(BUILD_LIBUDEV_COMPAT)/libudev-fs-test.o $(OBJ_TEST)
	$(CC) $(CFLAGS) $(INC) $(DEFS) -o "$@" "$<" $(OBJ_TEST) $(LIB) $(LIBINC)

$(BUILD_LIBUDEV_COMPAT)/libudev-fs-test.o: libudev-fs.c $(LIBUDEV_COMPAT_HEADERS)
	$(CC) $(CFLAGS) $(INC) $(DEFS) -o "$@" -c "$<" -DTEST

$(BUILD_LIBUDEV_COMPAT_HEADERS)/%.h: %.h
	@mkdir -p "$(shell dirname "$@")"
	cp -a "$<" "$@"

$(BUILD_LIBUDEV_COMPAT)/%.o: %.c $(LIBUDEV_COMPAT_HEADERS)
	@mkdir -p "$(shell dirname "$@")"
	$(CC) $(CFLAGS) $(INC) $(DEFS) -o "$@" -c "$<"

$(BUILD_LIBUDEV_COMPAT)/%.sym: %.sym
	@mkdir -p "$(shell dirname "$@")"
	cp -a "$<" "$@"

$(BUILD_LIBUDEV_COMPAT_PC): $(LIBUDEV_COMPAT_PC_IN)
	@mkdir -p "$(shell dirname "$@")"
	@cat "$<" | \
		sed -e 's~@prefix@~/$(PREFIX)~g; ' \
			 -e 's~//~/~g; ' \
			 -e 's~@libdir@~$(LIBDIR)~g; ' \
			 -e 's~@includedir@~$(INCLUDEDIR)~g; ' \
			 -e 's~@VERSION@~$(LIBUDEV_VERSION)~g; ' > "$@"

install: $(LIBUDEV_COMPAT_FILES_INSTALL) $(LIBUDEV_COMPAT_HEADERS_INSTALL) $(INSTALL_LIBUDEV_COMPAT_PC)

$(INSTALL_LIBUDEV_COMPAT)/%: $(BUILD_LIBUDEV_COMPAT)/%
	@mkdir -p "$(shell dirname "$@")"
	@rm -f "$@"
	cp -a "$<" "$@"

$(INSTALL_LIBUDEV_COMPAT_HEADERS)/%.h: $(BUILD_LIBUDEV_COMPAT_HEADERS)/%.h
	@mkdir -p "$(shell dirname "$@")"
	cp -a "$<" "$@"

$(INSTALL_LIBUDEV_COMPAT_PC): $(BUILD_LIBUDEV_COMPAT_PC)
	@mkdir -p "$(shell dirname "$@")"
	cp -a "$<" "$@"

.PHONY: uninstall
uninstall:
	rm -f $(LIBUDEV_COMPAT_FILES_INSTALL) $(LIBUDEV_COMPAT_HEADERS_INSTALL)

.PHONY: clean
clean:
	rm -f $(LIBUDEV_COMPAT_FILES) $(LIBUDEV_COMPAT_HEADERS) $(OBJ) $(SYM_BUILD)

=== vdev-initramfs/Makefile ===
include ../buildconf.mk

INITRAMFS_FILES := $(wildcard initramfs/hooks/*) \
                $(wildcard initramfs/scripts/init-bottom/*) \
                $(wildcard initramfs/scripts/init-top/*) \
		$(wildcard initramfs/modules.d/vdev) \
		$(wildcard initramfs/init)

INITRAMFS_BUILD := \
    $(patsubst initramfs/%,$(BUILD_VDEV_INITRAMFS)/%,$(INITRAMFS_FILES))

INITRAMFS_INSTALL := \
    $(patsubst initramfs/%,$(INSTALL_VDEV_INITRAMFS)/%,$(INITRAMFS_FILES))

VDEV_BUILD := $(INITRAMFS_BUILD) 
VDEV_INSTALL := $(INITRAMFS_INSTALL)

TOOLS := ../tools/
VDEVD := ../vdevd/

GEN_IFNAMES := $(BUILD_VDEVD_HELPERS)/gen-ifnames.sh
MKINITRAMFS := make-initramfs.sh
VDEV_INSTALL_SCRIPT := vdev-install.sh
VDEV_INSTALL_SCRIPT_INSTALL := $(INSTALL_VDEV_INSTALL_SCRIPT)/vdev-install.sh

# debugging
print-%: ; @echo $*=$($*)

all: $(VDEV_BUILD)

$(BUILD_VDEV_CONFIG)/actions/%: actions/%
	@mkdir -p $(shell dirname "$@")
	@rm -f "$@"
	@cat "$<" > "$@"

$(BUILD_VDEV_INITRAMFS)/%: initramfs/%
	@mkdir -p $(shell dirname "$@")
	@cp -a "$<" "$@"

$(INSTALL_VDEV_INITRAMFS)/%: $(BUILD_VDEV_INITRAMFS)/%
	@mkdir -p $(shell dirname "$@")
	@cp -a "$<" "$@"

$(VDEV_INSTALL_SCRIPT_INSTALL): $(VDEV_INSTALL_SCRIPT)
	@mkdir -p $(shell dirname "$@")
	@cp -a "$<" "$@"

.PHONY: initramfs
initramfs: $(VDEV_CONFIG_INSTALL) $(INITSCRIPT_INSTALL)
	$(SHELL) ./$(MKINITRAMFS)

.PHONY: install
install: $(VDEV_INSTALL) $(VDEV_INSTALL_SCRIPT_INSTALL)

.PHONY: clean
clean:
	rm -f $(VDEV_BUILD)

=== vdevd/Makefile ===
include ../buildconf.mk

C_SRCS := $(wildcard *.c) $(wildcard os/*.c) $(wildcard ../libvdev/*.c)

LIB   := -lpthread -lrt
OBJ   := $(patsubst %.c,$(BUILD_VDEVD)/%.o,$(C_SRCS))
VDEVD := $(BUILD_VDEVD)/vdevd

MANPAGES_INSTALL := $(patsubst debian/%,$(INSTALL_MAN8DIR)/%.gz,$(wildcard debian/*.8))

VDEVD_INSTALL := $(INSTALL_VDEVD)/vdevd

HELPERS_DIR := helpers/$(OS)

HWDB_DIR := $(ROOT_DIR)/hwdb

all: $(VDEVD) helpers

$(VDEVD): $(OBJ) helpers
	@mkdir -p "$(shell dirname "$@")"
	$(CC) -o $@ $(OBJ) $(LIB) $(LIBINC) $(LDFLAGS)

$(BUILD_VDEVD)/%.o : %.c
	@mkdir -p "$(shell dirname "$@")"
	$(CC) $(CFLAGS) $(DEFS) $(INC) -o "$@" -c "$<"

$(BUILD_LIBVDEV)/%.o: $(LIBVDEV_ROOT)/%.c
	@mkdir -p "$(shell dirname "$@")"
	$(CC) $(CFLAGS) $(DEFS) $(INC) -o "$@" -c "$<"

$(BUILD_MAN8DIR):
	@echo "===== MKDIR $@"
	@mkdir -p $@

$(BUILD_MAN8DIR)/%.gz: debian/% | $(BUILD_MAN8DIR)
	gzip < $< > $@

$(INSTALL_MAN8DIR):
	@mkdir -p $@

$(INSTALL_MAN8DIR)/%: $(BUILD_MAN8DIR)/% | $(INSTALL_MAN8DIR)
	@cp $< $@

.PHONY: helpers
helpers:
	$(MAKE) -C $(HELPERS_DIR)

.PHONY: helpers-install hwdb-install
helpers-install:
	$(MAKE) -C $(HELPERS_DIR) install

hwdb-install:
	$(MAKE) -C $(HWDB_DIR) install

conf-install:
	$(MAKE) -C ../vdev-initramfs -f conf.mk conf-install

install: $(VDEVD_INSTALL) helpers-install hwdb-install $(MANPAGES_INSTALL) \
	conf-install

$(VDEVD_INSTALL): $(VDEVD)
	@mkdir -p $(INSTALL_VDEVD)
	@rm -f "$@"
	cp -a "$<" "$@"

.PHONY: clean
clean:
	rm -f $(OBJ) $(VDEVD)
	$(MAKE) -C $(HELPERS_DIR) clean

.PHONY: uninstall
uninstall:
	rm -f $(VDEVD)
	$(MAKE) -C $(HELPERS_DIR) uninstall

=== vdevd/helpers/LINUX/Makefile ===
include ../../../buildconf.mk

C_SRCS:= $(wildcard *.c) 
CXSRCS:= $(wildcard *.cpp) 
OBJ   := $(patsubst %.c,$(BUILD_VDEVD_HELPERS)/%.o,$(C_SRCS)) $(patsubst %.cpp,$(BUILD_VDEVD_HELPERS)/%.o,$(CXSRCS))
LIB   := -lrt

HELPER_SCRIPTS := $(wildcard *.sh) daemonlet
HELPERS := stat_optical stat_ata stat_input stat_scsi stat_v4l stat_net stat_usb stat_bus stat_path event-put echo_n $(HELPER_SCRIPTS)

HELPERS_BUILD := $(patsubst %,$(BUILD_VDEVD_HELPERS)/%,$(HELPERS))
HELPERS_INSTALL := $(patsubst %,$(INSTALL_VDEVD_HELPERS)/%,$(HELPERS))

all: $(HELPERS_BUILD)

$(BUILD_VDEVD_HELPERS)/%: $(BUILD_VDEVD_HELPERS)/%.o $(BUILD_VDEVD_HELPERS)/common.o
	@mkdir -p "$(shell dirname "$@")"
	$(CC) -o "$@" "$<" $(BUILD_VDEVD_HELPERS)/common.o $(LIBINC) $(LIB) $(LDFLAGS)

$(BUILD_VDEVD_HELPERS)/%.o: %.c
	@mkdir -p "$(shell dirname "$@")"
	$(CC) $(CFLAGS) $(DEFS) $(INC) -o "$@" -c "$<"

$(BUILD_VDEVD_HELPERS)/%.sh: %.sh
	@mkdir -p "$(shell dirname "$@")"
	cp -a "$<" "$@"

$(BUILD_VDEVD_HELPERS)/daemonlet: daemonlet
	@mkdir -p "$(shell dirname "$@")"
	cp -a "$<" "$@"

install: $(HELPERS_INSTALL)
$(INSTALL_VDEVD_HELPERS)/%: $(BUILD_VDEVD_HELPERS)/%
	@mkdir -p "$(shell dirname "$@")"
	@rm -f "$@"
	cp -a "$<" "$@"

.PHONY: uninstall
uninstall:
	rm -f $(HELPERS_INSTALL)

.PHONY: clean
clean:
	rm -f $(OBJ) $(HELPERS_BUILD)

=== debian/changelog ===
vdev (0.1.2) unstable; urgency=low

  * Corrected build configuration to put lib in x86_64 for amd64

 -- Ralph Ronnquist <ralph.ronnquist@gmail.com>  Tue, 17 Jan 2017 20:35:01 +1100

vdev (0.1.1) unstable; urgency=low

  * Initial release

 -- Ralph Ronnquist <ralph.ronnquist@gmail.com>  Tue, 17 Jan 2017 20:35:01 +1100

=== debian/control ===
Source: vdev
Section: admin
Priority: optional
Maintainer: Ralph Ronnquist <ralph.ronnquist@gmail.com>
Build-Depends: debhelper (>= 9)
# vdevfs needs libfuse, libpstat, fskit
Standards-Version: 3.9.5
Homepage: <insert the upstream URL, if relevant>
#Vcs-Git: git://anonscm.debian.org/collab-maint/vdev.git
#Vcs-Browser: http://anonscm.debian.org/?p=collab-maint/vdev.git;a=summary

Package: vdev
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Replaces: libudev1-compat, vdevd, vdev-initramfs
Description: A device-file manager and filesystem
 Vdev is a portable userspace device-file manager for UNIX-like
 operating systems. It differs from existing device-file managers in
 that it provides an optional filesystem interface that implements a
 per-process view of /dev, thereby giving the host administrator the
 means to control device node access based on arbitrary criteria (such
 as process session ID, process seat assignment, etc.).

## vdev 1.0

=== Makefile ===
include buildconf.mk

.PHONY: all
all:
	$(MAKE) -C vdevd
	#$(MAKE) -C fs
	$(MAKE) -C vdev-initramfs
	$(MAKE) -C hwdb

.PHONY: install
install:
	$(MAKE) -C vdevd install
	#$(MAKE) -C fs install
	$(MAKE) -C vdev-initramfs install
	$(MAKE) -C hwdb install

.PHONY: clean
clean:
	$(MAKE) -C vdevd clean
#	$(MAKE) -C fs clean
	$(MAKE) -C vdev-initramfs clean
	$(MAKE) -C hwdb clean

.PHONY: uninstall
uninstall:
	$(MAKE) -C vdevd uninstall
#	$(MAKE) -C fs uninstall
	$(MAKE) -C vdev-initramfs uninstall
	$(MAKE) -C hwdb uninstall

.PHONY: deb jail
deb:
	make -f debian.mk

jail:
	firejail --overlay make -f debian.mk

=== debian/changelog ===
vdev (1.0) unstable; urgency=low

  * Initial release

 -- Ralph Ronnquist <ralph.ronnquist@gmail.com>  Tue, 17 Jan 2017 20:35:01 +1100

=== libudev-compat/debian/changelog ===
libudev1-compat (1.2.2) unstable; urgency=low

  * Added all packaging control script

 -- Ralph Ronnquist <ralph.ronnquist@gmail.com>  Thu, 12 Jan 2017 21:55:55 +1000

libudev1-compat (1.2.1) unstable; urgency=low

  * Declared SONAME libudev.so.1 so as to persist link setting

 -- Ralph Ronnquist <ralph.ronnquist@gmail.com>  Wed, 07 Sep 2016 18:39:05 +1000

libudev1-compat (1.2) unstable; urgency=low

  * Reverted to free-standing packaging (not replacing libudev1)

 -- Ralph Ronnquist <ralph.ronnquist@gmail.com>  Wed, 07 Sep 2016 18:39:05 +1000

libudev1-compat (1.1) unstable; urgency=low

  * Packaging setup to provide, conflict and replace libudev1

 -- Ralph Ronnquist <ralph.ronnquist@gmail.com>  Sun, 04 Sep 2016 11:19:48 +1000

libudev1-compat (1.0beta-1) unstable; urgency=low

  * Initial release (Closes: #nnnn)  <nnnn is the bug number of your ITP>

 -- Ralph Ronnquist <ralph.ronnquist@gmail.com>  Sun, 28 Aug 2016 11:19:48 +1000

=== vdev-initramfs/debian/changelog ===
vdev (1.2.8) unstable; urgency=low

  * Added all packaging scripts

 -- Ralph Ronnquist <ralph.ronnquist@gmail.com>  Thu, 12 Jan 2017 22:18:45 +1000

vdev (1.2.7) unstable; urgency=low

  * Updated vdev-install.sh script to manage libudev.so better

 -- Ralph Ronnquist <ralph.ronnquist@gmail.com>  Wed, 12 Oct 2016 15:14:44 +1000

vdev (1.2.6) unstable; urgency=low

  * Updated vdev-install.sh script to manage libudev.so better

 -- Ralph Ronnquist <ralph.ronnquist@gmail.com>  Wed, 12 Oct 2016 11:04:59 +1000

vdev (1.2.5) unstable; urgency=low

  * Polishing package installation, and vdev-install.sh script.

 -- Ralph Ronnquist <ralph.ronnquist@gmail.com>  Sun, 02 Oct 2016 13:21:51 +1000

vdev (1.2.4) unstable; urgency=low

  * Improved vdev-install.sh to use /etc/insserv/overrides for avoiding that insserv sees conflicting definitions of "udev".

 -- Ralph Ronnquist <ralph.ronnquist@gmail.com>  Fri, 30 Sep 2016 23:23:18 +1000

vdev (1.2.3) unstable; urgency=low

  * Updated vdev-install.sh to juggle libudev.so.1 link better

 -- Ralph Ronnquist <ralph.ronnquist@gmail.com>  Sat, 10 Sep 2016 15:22:02 +1000

vdev (1.2.2) unstable; urgency=low

  * Made pre-pivot run quiet, and corrected the init-bottom script

 -- Ralph Ronnquist <ralph.ronnquist@gmail.com>  Sat, 10 Sep 2016 15:22:02 +1000

vdev (1.2.1) unstable; urgency=low

  * Added a prerm script to revert to udev before removing vdev.

 -- Ralph Ronnquist <ralph.ronnquist@gmail.com>  Sat, 10 Sep 2016 15:22:02 +1000

vdev (1.2) unstable; urgency=low

  * Included a postinst script for manual choice between udev and vdev.

 -- Ralph Ronnquist <ralph.ronnquist@gmail.com>  Wed, 07 Sep 2016 18:39:05 +1000

vdev (1.1) unstable; urgency=low

  * Revision attempting to play nicely with udev

 -- Ralph Ronnquist <ralph.ronnquist@gmail.com>  Sun, 04 Sep 2016 11:19:57 +1000

vdev (1.0beta-1) unstable; urgency=low

  * Initial release (Closes: #nnnn)  <nnnn is the bug number of your ITP>

 -- Ralph Ronnquist <ralph.ronnquist@gmail.com>  Sun, 28 Aug 2016 11:19:57 +1000

=== vdevd/debian/changelog ===
vdevd (2.0.3) unstable; urgency=low

  * Populated all build scripts, including prerm to remove the udev script capture, and thus allow /usr/share/vdev to be removed.

 -- Ralph Ronnquist <ralph.ronnquist@gmail.com>  Thu, 12 Jan 2017 21:47:55 +1000

vdevd (2.0.2) unstable; urgency=low

  * Correction to hwdb access via DEVPATH, i.e. idVendor/idProduct.

 -- Ralph Ronnquist <ralph.ronnquist@gmail.com>  Tue, 11 Oct 2016 00:14:58 +1000

vdevd (2.0.1) unstable; urgency=low

  * Corrections to compiled rules handling.

 -- Ralph Ronnquist <ralph.ronnquist@gmail.com>  Mon, 10 Oct 2016 14:24:55 +1000

vdevd (2.0) unstable; urgency=low

  * First attempt with "compiled rules" acivated.
  * Includes the actions and helpers for beta testing of compiled rules.

 -- Ralph Ronnquist <ralph.ronnquist@gmail.com>  Sun, 09 Oct 2016 09:22:26 +1000

vdevd (1.2.2) unstable; urgency=low

  * Moved overrides file to /etc/insserv/overrides/vdev
  * Changed initial loglevel to "info"

 -- Ralph Ronnquist <ralph.ronnquist@gmail.com>  Sun, 02 Oct 2016 13:24:23 +1000

vdevd (1.2.1) unstable; urgency=low

  * Moved all postinst activity from here into the vded-initramfs package
  * Added /etc/vdev/insserv-overrides-udev template to support choice between udev and vdev
  * Included compiled udev rules into hwdb (without supporting actions)

 -- Ralph Ronnquist <ralph.ronnquist@gmail.com>  Fri, 30 Sep 2016 22:57:59 +1000

vdevd (1.2) unstable; urgency=low

  * No longer provides "udev".

 -- Ralph Ronnquist <ralph.ronnquist@gmail.com>  Wed, 07 Sep 2016 18:39:05 +1000

vdevd (1.1) unstable; urgency=low

  * Versioning consolidation

 -- Ralph Ronnquist <ralph.ronnquist@gmail.com>  Sun, 04 Sep 2016 00:17:55 +1000

vdevd (1.0beta-3) unstable; urgency=low

  * Change to include all runtime configuration.

 -- Ralph Ronnquist <ralph.ronnquist@gmail.com>  Tue, 02 Sep 2016 00:17:55 +1000

vdevd (1.0beta-2) unstable; urgency=low

  * Added first draft of man pages.

 -- Ralph Ronnquist <ralph.ronnquist@gmail.com>  Tue, 30 Aug 2016 12:50:13 +1000

vdevd (1.0beta-1) unstable; urgency=low

  * Initial release (Closes: #nnnn)  <nnnn is the bug number of your ITP>

 -- Ralph Ronnquist <ralph.ronnquist@gmail.com>  Sun, 28 Aug 2016 11:19:35 +1000

=== debian/control ===
--- 
+++ 
@@ -1,5 +1,5 @@
 Source: vdev
-Section: admin
+Section: unknown
 Priority: optional
 Maintainer: Ralph Ronnquist <ralph.ronnquist@gmail.com>
 Build-Depends: debhelper (>= 9)
@@ -12,7 +12,6 @@
 Package: vdev
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
-Replaces: libudev1-compat, vdevd, vdev-initramfs
 Description: A device-file manager and filesystem
  Vdev is a portable userspace device-file manager for UNIX-like
  operating systems. It differs from existing device-file managers in

=== libudev-compat/debian/control ===
Source: libudev1-compat
Section: admin
Priority: important
Maintainer: Ralph Ronnquist <ralph.ronnquist@gmail.com>
Build-Depends: debhelper (>= 9)
Standards-Version: 3.9.5
Homepage: https://git.devuan.org/ralph.ronnquist/vdev

Package: libudev1-compat
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Vdev is a portable userspace device-file manager.
 Vdev is a portable userspace device-file manager for UNIX-like
 operating systems. It differs from existing device-file managers in
 that it provides an optional filesystem interface that implements a
 per-process view of /dev, thereby giving the host administrator the
 means to control device node access based on arbitrary criteria (such
 as process session ID, process seat assignment, etc.).
 .
 This package provides libudev1 compatbility library for using vdev
 as /dev manager instead of udev.

=== vdev-initramfs/debian/control ===
Source: vdev
Section: admin
Priority: important
Maintainer: Ralph Ronnquist <ralph.ronnquist@gmail.com>
Build-Depends: debhelper (>= 9)
Standards-Version: 3.9.5
Homepage: https://git.devuan.org/ralph.ronnquist/vdev

Package: vdev-initramfs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, vdevd, libudev1-compat
Suggests: dialog
Description: Vdev is a portable userspace device-file manager.
 Vdev is a portable userspace device-file manager for UNIX-like
 operating systems. It differs from existing device-file managers in
 that it provides an optional filesystem interface that implements a
 per-process view of /dev, thereby giving the host administrator the
 means to control device node access based on arbitrary criteria (such
 as process session ID, process seat assignment, etc.).
 .
 This package provides the setup for adding vdevd to initramfs, and
 the control script for choice between vdev and udev.

=== vdevd/debian/control ===
Source: vdevd
Section: admin
Priority: important
Maintainer: Ralph Ronnquist <ralph.ronnquist@gmail.com>
Build-Depends: debhelper (>= 9)
Standards-Version: 3.9.5
Homepage: https://git.devuan.org/ralph.ronnquist/vdev

Package: vdevd
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Vdev is a portable userspace device-file manager.
 Vdev is a portable userspace device-file manager for UNIX-like
 operating systems. It differs from existing device-file managers in
 that it provides an optional filesystem interface that implements a
 per-process view of /dev, thereby giving the host administrator the
 means to control device node access based on arbitrary criteria (such
 as process session ID, process seat assignment, etc.).
 .
 This package provides the runtime daemon for using vdev as /dev
 manager.

=== vdevd/debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#DH_VERBOSE = 1

# see EXAMPLES in dpkg-buildflags(1) and read /usr/share/dpkg/*
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

# see FEATURE AREAS in dpkg-buildflags(1)
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed


# main packaging script based on dh7 syntax
%:
	dh $@ 

# debmake generated override targets
# This is example for Cmake (See http://bugs.debian.org/641051 )
#override_dh_auto_configure:
#	dh_auto_configure -- \
#	-DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH)

## vdev 1.3.67

=== Makefile ===
include buildconf.mk

.PHONY: all
all:
	$(MAKE) -C libvdev PREFIX=
	$(MAKE) -C vdevd PREFIX=
	$(MAKE) -C fs PREFIX=
	$(MAKE) -C hwdb PREFIX=
	$(MAKE) -C example PREFIX=

.PHONY: install
install:
	$(MAKE) -C libvdev install PREFIX=
	$(MAKE) -C vdevd install PREFIX=
	$(MAKE) -C fs install PREFIX=
	$(MAKE) -C hwdb install PREFIX=
	$(MAKE) -C example install PREFIX=

	# Installing documentation
	mkdir -p $(DESTDIR)/usr/share/doc
	mkdir -p $(DESTDIR)/usr/share/man
	mkdir -p $(DESTDIR)/usr/share/man/man8
	cp -r share/doc/ $(DESTDIR)/usr/share/doc
	cp -r share/man/man8/ $(DESTDIR)/usr/share/man/man8

.PHONY: uninstall
uninstall:
	$(MAKE) -C libvdev uninstall
	$(MAKE) -C vdevd uninstall
	$(MAKE) -C fs uninstall
	$(MAKE) -C example uninstall
	$(MAKE) -C hwdb uninstall

	# Uninstalling documentation
	rm -rf $(DESTDIR)/usr/share/doc/vdevd
	rm -rf $(DESTDIR)/usr/share/man/man8/vdevd.8.gz
	rm -rf $(DESTDIR)/usr/share/man/man8/vdevd-actions.8.gz

.PHONY: clean
clean:
	$(MAKE) -C libvdev clean
	$(MAKE) -C vdevd clean
	$(MAKE) -C fs clean
	$(MAKE) -C example clean
	$(MAKE) -C hwdb clean

=== example/Makefile ===
include ../buildconf.mk

INITRAMFS_FILES := $(wildcard initramfs/hooks/*) \
                $(wildcard initramfs/scripts/init-bottom/*) \
                $(wildcard initramfs/scripts/init-top/*) \
		$(wildcard initramfs/modules.d/vdev) \
		$(wildcard initramfs/init)

INITRAMFS_BUILD := \
    $(patsubst initramfs/%,$(BUILD_VDEV_INITRAMFS)/%,$(INITRAMFS_FILES))

INITRAMFS_INSTALL := \
    $(patsubst initramfs/%,$(INSTALL_VDEV_INITRAMFS)/%,$(INITRAMFS_FILES))

VDEV_BUILD := $(INITRAMFS_BUILD) 
VDEV_INSTALL := $(INITRAMFS_INSTALL)

TOOLS := ../tools/
VDEVD := ../vdevd/

GEN_IFNAMES := $(BUILD_VDEVD_HELPERS)/gen-ifnames.sh
MKINITRAMFS := make-initramfs.sh

# debugging
print-%: ; @echo $*=$($*)

all: $(VDEV_BUILD)

$(BUILD_VDEV_CONFIG)/actions/%: actions/%
	@mkdir -p $(shell dirname "$@")
	@rm -f "$@"
	@cat "$<" > "$@"

$(BUILD_VDEV_INITRAMFS)/%: initramfs/%
	@mkdir -p $(shell dirname "$@")
	@cp -a "$<" "$@"

$(INSTALL_VDEV_INITRAMFS)/%: $(BUILD_VDEV_INITRAMFS)/%
	@mkdir -p $(shell dirname "$@")
	@cp -a "$<" "$@"

$(VDEV_INSTALL_SCRIPT_INSTALL): $(VDEV_INSTALL_SCRIPT)
	@mkdir -p $(shell dirname "$@")
	@cp -a "$<" "$@"

.PHONY: initramfs
initramfs: $(VDEV_CONFIG_INSTALL) $(INITSCRIPT_INSTALL)
	$(SHELL) ./$(MKINITRAMFS)

.PHONY: install
install: $(VDEV_INSTALL) $(VDEV_INSTALL_SCRIPT_INSTALL)

.PHONY: clean
clean:
	rm -f $(VDEV_BUILD)

=== fs/Makefile ===
include ../buildconf.mk

C_SRCS:= $(wildcard *.c) $(wildcard ../libvdev/*.c)

DEFS  := $(DEFS) -D_FILE_OFFSET_BITS=64
LIB   := -lfuse -lfskit_fuse -lfskit -lpstat
OBJ   := $(patsubst %.c,$(BUILD_VDEVFS)/%.o,$(C_SRCS)) \

VDEVFS := $(BUILD_VDEVFS)/vdevfs

VDEVFS_INSTALL := $(INSTALL_VDEVFS)/vdevfs

all: $(VDEVFS)

$(VDEVFS): $(OBJ)
	@mkdir -p "$(shell dirname "$@")"
	$(CC) $(LDFLAGS) -o "$@" $(OBJ) $(LIBINC) $(LIB)

$(BUILD_VDEVFS)/%.o : %.c
	@mkdir -p "$(shell dirname "$@")"
	$(CC) $(CFLAGS) $(INC) $(DEFS) -o "$@" -c "$<"

install: $(VDEVFS_INSTALL)
$(VDEVFS_INSTALL): $(VDEVFS)
	@mkdir -p "$(shell dirname "$@")"
	cp -a "$<" "$@"

.PHONY: clean
clean:
	rm -f $(OBJ) $(VDEVFS)

.PHONY: uninstall
uninstall:
	rm -f $(VDEVFS_INSTALL)

=== hwdb/Makefile ===
include ../buildconf.mk

HWDB_INPUT := $(wildcard udev/*.hwdb)
HWDB_GEN := gen_database.sh
HWDB_BUILD_INPUT := $(patsubst udev/%.hwdb,$(BUILD_HWDB)/input/%.hwdb,$(HWDB_INPUT))
HWDB_BUILD_GEN := $(patsubst %,$(BUILD_HWDB)/%,$(HWDB_GEN))
HWDB_BUILD := $(BUILD_HWDB)/hwdb.squashfs

HWDB_INSTALL := $(INSTALL_HWDB)/hwdb.squashfs 

all: $(HWDB_BUILD)

$(HWDB_BUILD): $(HWDB_BUILD_INPUT) $(HWDB_BUILD_GEN)
	if [ -f hwdb.squashfs ]; then \
	  	cp -a hwdb.squashfs "$@"; \
	else \
		echo "Generating hardware database"; \
		mkdir -p "$@.dir"; \
		$(BUILD_HWDB)/gen_database.sh -o "$@.dir" $(BUILD_HWDB)/input/*.hwdb; \
		mksquashfs "$@.dir" "$@" -force-uid 0 -force-gid 0; \
	fi

$(BUILD_HWDB)/input/%.hwdb: udev/%.hwdb
	@mkdir -p "$(shell dirname "$@")"
	@cp -a "$<" "$@"

$(BUILD_HWDB)/%.sh: %.sh
	@mkdir -p "$(shell dirname "$@")"
	@cp -a "$<" "$@"

install: $(HWDB_INSTALL)

$(INSTALL_HWDB)/%: $(BUILD_HWDB)/%
	mkdir -p "$(shell dirname "$@")"
	cp -a "$<" "$@"

.PHONY: uninstall
uninstall:
	rm -f "$(HWDB_INSTALL)"

.PHONY: clean 
clean:
	rm -rf $(HWDB_BUILD) $(HWDB_BUILD_INPUT) $(HWDB_BUILD_GEN) $(HWDB_BUILD).dir

print-%: ; @echo $*=$($*)

=== libvdev/Makefile ===
include ../buildconf.mk

CFLAGS := -Wall -g -fPIC -fstack-protector -fstack-protector-all -pthread -Wno-unused-variable -Wno-unused-but-set-variable
INC := $(INC) -I$(BUILD_LIBVDEV_HEADERS)
DEFS := $(DEFS) -D_POSIX_C_SOURCE=200809L -D_DEFAULT_SOURCE -D_GNU_SOURCE
CC   := cc

C_SRCS:= $(wildcard *.c)

HEADERS := $(wildcard *.h)
OBJ := $(patsubst %.c,$(BUILD_LIBVDEV)/%.o,$(C_SRCS))
LIB :=

VERSION_MAJOR := 1
VERSION_MINOR := 0
VERSION_PATCH := 0

LIBVDEV := $(BUILD_LIBVDEV)/libvdev.so
LIBVDEV_SONAME := libvdev.so.$(VERSION_MAJOR)
LIBVDEV_LIB := $(BUILD_LIBVDEV)/libvdev.so.$(VERSION_MAJOR).$(VERSION_MINOR).$(VERSION_PATCH)

LIBVDEV_FILES := $(LIBVDEV) $(BUILD_LIBVDEV)/$(LIBVDEV_SONAME) $(LIBVDEV_LIB)

LIBVDEV_HEADERS := $(patsubst %.h,$(BUILD_LIBVDEV_HEADERS)/%.h,$(HEADERS))

LIBVDEV_INSTALL_HEADERS := $(patsubst $(BUILD_LIBVDEV_HEADERS)/%,$(INSTALL_LIBVDEV_HEADERS)/%,$(LIBVDEV_HEADERS))

LIBVDEV_FILES_INSTALL := $(patsubst $(BUILD_LIBVDEV)/%,$(INSTALL_LIBVDEV)/%,$(LIBVDEV_FILES))

LIBVDEV_HEADERS_INSTALL := $(patsubst $(BUILD_LIBVDEV_HEADERS)/%.h,$(INSTALL_LIBVDEV_HEADERS)/%.h,$(LIBVDEV_INSTALL_HEADERS))

LIBVDEV_PC_IN := libvdev.pc.in
BUILD_LIBVDEV_PC := $(BUILD_PKGCONFIG)/libvdev.pc
INSTALL_LIBVDEV_PC := $(DESTDIR)$(PKGCONFIG)/libvdev.pc

all: $(LIBVDEV_FILES) $(LIBVDEV_HEADERS) $(BUILD_LIBVDEV_PC)

$(LIBVDEV_LIB): $(OBJ)
	@mkdir -p "$(shell dirname "$@")"
	$(CC) $(CFLAGS) $(INC) $(DEFS) -shared -Wl,-soname,$(LIBVDEV_SONAME) -o "$@" $(OBJ) $(LIBINC) $(LIB)

$(BUILD_LIBVDEV)/$(LIBVDEV_SONAME): $(LIBVDEV_LIB)
	@mkdir -p "$(shell dirname "$@")"
	@ln -sf "$(shell basename "$<")" "$@"

$(LIBVDEV): $(BUILD_LIBVDEV)/$(LIBVDEV_SONAME)
	@mkdir -p "$(shell dirname "$@")"
	@ln -sf "$(shell basename "$<")" "$@"

$(BUILD_LIBVDEV_HEADERS)/%.h: %.h
	@mkdir -p "$(shell dirname "$@")"
	cp -a "$<" "$@"

$(BUILD_LIBVDEV)/%.o: %.c $(LIBVDEV_HEADERS)
	@mkdir -p "$(shell dirname "$@")"
	$(CC) $(CFLAGS) $(INC) $(DEFS) -o "$@" -c "$<"

$(BUILD_LIBVDEV_PC): $(LIBVDEV_PC_IN)
	@mkdir -p "$(shell dirname "$@")"
	@cat "$<" | \
		sed -e 's~@prefix@~/$(PREFIX)~g; ' \
			 -e 's~//~/~g; ' \
			 -e 's~@libdir@~$(LIBDIR)~g; ' \
			 -e 's~@includedir@~$(INCLUDEDIR)~g; ' \
			 -e 's~@VERSION@~$(LIBUDEV_VERSION)~g; ' > "$@"

install: $(LIBVDEV_FILES_INSTALL) $(LIBVDEV_HEADERS_INSTALL) $(INSTALL_LIBVDEV_PC)

$(INSTALL_LIBVDEV)/%: $(BUILD_LIBVDEV)/%
	@mkdir -p "$(shell dirname "$@")"
	@rm -f "$@"
	cp -a "$<" "$@"
	SO_EXISTS="$(shell test -L $(BUILD_LIBVDEV)/libvdev.so && echo 1 || echo 0)"
ifeq ($(SO_EXISTS), 0)
	cp -as --preserve=links $(BUILD_LIBVDEV)/libvdev.so $(INSTALL_LIBVDEV)
endif	

$(INSTALL_LIBVDEV_HEADERS)/%.h: $(BUILD_LIBVDEV_HEADERS)/%.h
	@mkdir -p "$(shell dirname "$@")"
	cp -a "$<" "$@"

$(INSTALL_LIBVDEV_PC): $(BUILD_LIBVDEV_PC)
	@mkdir -p "$(shell dirname "$@")"
	cp -a "$<" "$@"

.PHONY: uninstall
uninstall:
	rm -f $(LIBVDEV_FILES_INSTALL) $(LIBVDEV_HEADERS_INSTALL) $(INSTALL_LIBVDEV_PC) $(DESTDIR)$(LIBDIR)/libvdev.so

.PHONY: clean
clean:
	rm -f $(LIBVDEV_FILES) $(LIBVDEV_HEADERS) $(OBJ) $(BUILD_LIBVDEV_PC) $(LIBVDEV)

.SILENT: print_version_major
print_version_major:
	@echo $(VERSION_MAJOR)

=== pkg/Makefile ===
all: deb

deb:
	./pkg-deb.sh

.PHONY: clean
clean:
	/bin/rm -f *.deb

=== vdevd/Makefile ===
--- 
+++ 
@@ -1,8 +1,8 @@
 include ../buildconf.mk
 
-C_SRCS := $(wildcard *.c) $(wildcard os/*.c) $(wildcard ../libvdev/*.c)
+C_SRCS := $(wildcard *.c) $(wildcard os/*.c)
 
-LIB   := -lpthread -lrt
+LIB   := -lpthread -lrt -L$(BUILD_LIBVDEV) -lvdev
 OBJ   := $(patsubst %.c,$(BUILD_VDEVD)/%.o,$(C_SRCS))
 VDEVD := $(BUILD_VDEVD)/vdevd
 
@@ -14,19 +14,15 @@
 
 HWDB_DIR := $(ROOT_DIR)/hwdb
 
-all: $(VDEVD) helpers
+all: $(VDEVD) helpers	
 
 $(VDEVD): $(OBJ) helpers
 	@mkdir -p "$(shell dirname "$@")"
-	$(CC) -o $@ $(OBJ) $(LIB) $(LIBINC) $(LDFLAGS)
+	$(CC) -L$(BUILD_LIBVDEV)/libvdev.so -o $@ $(OBJ) $(LIB) $(LIBINC) $(LDFLAGS)
 
 $(BUILD_VDEVD)/%.o : %.c
 	@mkdir -p "$(shell dirname "$@")"
-	$(CC) $(CFLAGS) $(DEFS) $(INC) -o "$@" -c "$<"
-
-$(BUILD_LIBVDEV)/%.o: $(LIBVDEV_ROOT)/%.c
-	@mkdir -p "$(shell dirname "$@")"
-	$(CC) $(CFLAGS) $(DEFS) $(INC) -o "$@" -c "$<"
+	$(CC) $(CFLAGS) $(DEFS) $(INC) -I$(BUILD)/include -o "$@" -c "$<"
 
 $(BUILD_MAN8DIR):
 	@echo "===== MKDIR $@"
@@ -46,6 +42,7 @@
 	$(MAKE) -C $(HELPERS_DIR)
 
 .PHONY: helpers-install hwdb-install
+
 helpers-install:
 	$(MAKE) -C $(HELPERS_DIR) install
 
@@ -53,7 +50,7 @@
 	$(MAKE) -C $(HWDB_DIR) install
 
 conf-install:
-	$(MAKE) -C ../vdev-initramfs -f conf.mk conf-install
+	$(MAKE) -C ../example -f conf.mk conf-install
 
 install: $(VDEVD_INSTALL) helpers-install hwdb-install $(MANPAGES_INSTALL) \
 	conf-install

=== tools/udev_to_vdev/Makefile ===
CC       ?= cc
CXX      ?= c++
CFLAGS   ?= -Wall -g
CXXFLAGS ?= -Wall -g -std=c++11
LIB   := 
INC   := -I/usr/include -I/usr/local/include -I. 
C_SRCS:= $(wildcard *.c)
CXX_SRCS:= $(wildcard *.cpp)
OBJ   := $(patsubst %.c,%.o,$(C_SRCS)) $(patsubst %.cpp,%.o,$(CXX_SRCS))
DEFS  := -D_REENTRANT -D_THREAD_SAFE -D__STDC_FORMAT_MACROS

UDEV_TO_VDEV := udev2vdev

DESTDIR := /
BIN_DIR := /usr/local/bin

all: udev2vdev

udev2vdev: $(OBJ)
	$(CXX) -o $(UDEV_TO_VDEV) $(OBJ) $(LIBINC) $(LIB)

%.o : %.c
	$(CC) $(CFLAGS) -o $@ $(INC) -c $< $(DEFS)

%.o : %.cpp
	$(CXX) $(CXXFLAGS) -o $@ $(INC) -c $< $(DEFS)

.PHONY: clean
clean:
	/bin/rm -f $(OBJ) $(UDEV_TO_VDEV)

=== vdevd/helpers/LINUX/Makefile ===
--- 
+++ 
@@ -3,10 +3,13 @@
 C_SRCS:= $(wildcard *.c) 
 CXSRCS:= $(wildcard *.cpp) 
 OBJ   := $(patsubst %.c,$(BUILD_VDEVD_HELPERS)/%.o,$(C_SRCS)) $(patsubst %.cpp,$(BUILD_VDEVD_HELPERS)/%.o,$(CXSRCS))
-LIB   := -lrt
+LIB   := -lrt -lblkid `pkg-config --libs libudev libevdev libinput` -L$(BUILD_LIBVDEV) -lvdev
+CFLAGS += `pkg-config --cflags libudev libevdev libinput`
+#LIB   := -lrt -lblkid `pkg-config --libs libudev` -L$(BUILD_LIBVDEV) -lvdev
+#CFLAGS += `pkg-config --cflags libudev`
 
 HELPER_SCRIPTS := $(wildcard *.sh) daemonlet
-HELPERS := stat_optical stat_ata stat_input stat_scsi stat_v4l stat_net stat_usb stat_bus stat_path event-put echo_n $(HELPER_SCRIPTS)
+HELPERS := stat_optical stat_ata stat_input stat_scsi stat_v4l stat_net stat_usb stat_bus stat_path event-put echo_n cdrom_id vdev_block_info vdev_modprobe vdev_bind_input_devices vdev_reset_usb_devices vdev_print_input_devices vdev_root_sys_block vdev_wait vdev_killall $(HELPER_SCRIPTS)
 
 HELPERS_BUILD := $(patsubst %,$(BUILD_VDEVD_HELPERS)/%,$(HELPERS))
 HELPERS_INSTALL := $(patsubst %,$(INSTALL_VDEVD_HELPERS)/%,$(HELPERS))
@@ -15,11 +18,11 @@
 
 $(BUILD_VDEVD_HELPERS)/%: $(BUILD_VDEVD_HELPERS)/%.o $(BUILD_VDEVD_HELPERS)/common.o
 	@mkdir -p "$(shell dirname "$@")"
-	$(CC) -o "$@" "$<" $(BUILD_VDEVD_HELPERS)/common.o $(LIBINC) $(LIB) $(LDFLAGS)
+	$(CC) -L$(BUILD_LIBVDEV)/libvdev.so -o "$@" "$<" $(BUILD_VDEVD_HELPERS)/common.o $(LIBINC) $(LIB) $(LDFLAGS)
 
 $(BUILD_VDEVD_HELPERS)/%.o: %.c
 	@mkdir -p "$(shell dirname "$@")"
-	$(CC) $(CFLAGS) $(DEFS) $(INC) -o "$@" -c "$<"
+	$(CC) -D_GNU_SOURCE $(CFLAGS) $(DEFS) $(INC) $(LIBINC) -o "$@" -c "$<"
 
 $(BUILD_VDEVD_HELPERS)/%.sh: %.sh
 	@mkdir -p "$(shell dirname "$@")"

=== debian/changelog ===
vdev (1.3.67-1+5gnuinos1) unstable; urgency=medium

  * Request TERM signal in daemonlets if parent exits
  * New upstream version 1.3.67

 -- Aitor <aitor_czr@gnuinos.org>  Thu, 16 Oct 2025 23:19:29 +0200

vdev (1.3.66-1+5gnuinos1) unstable; urgency=medium

  * Add missing sysfs mountpoint prefix to $_ROOTSYSBLOCK variable 
    in the helper subr-event.sh
  * New upstream version 1.3.66

 -- Aitor <aitor_czr@gnuinos.org>  Sun, 12 Oct 2025 20:38:59 +0200

vdev (1.3.65-1+5gnuinos3) unstable; urgency=medium

  * Add --sysinit parameter to the vgchange command in forcelvm as 
    suggested in its manpages when it's being invoked from early 
    system initialisation scripts (e.g. rc.sysinit or an initrd), 
    before writable filesystems are available

 -- Aitor <aitor_czr@gnuinos.org>  Wed, 08 Oct 2025 16:35:31 +0200

vdev (1.3.65-1+5gnuinos2) unstable; urgency=medium

  * Run initramfs-tools/scripts/local-block/forcelvm only if lvm2 
    is present in the initial ram disk

 -- Aitor <aitor_czr@gnuinos.org>  Sun, 05 Oct 2025 20:02:41 +0200

vdev (1.3.65-1+5gnuinos1) unstable; urgency=medium

  * Added dri.act to actions.1
  * Added drm susbsystem to the set of subsystems taken into account 
    in both vdev_modprobe and vdevd.1.conf
  * New upstream version 1.3.65

 -- Aitor <aitor_czr@gnuinos.org>  Sat, 04 Oct 2025 00:14:42 +0200

vdev (1.3.64-1+5gnuinos4) unstable; urgency=medium

  * Add missing quotes in expresions like [ "$foo" -eq "1" ] existent 
    in disk.sh that caused warnings related to "Illegal numbers" being 
    parsed in the daemonlet
  * New upstream version 1.3.64

 -- Aitor <aitor_czr@gnuinos.org>  Sun, 07 Sep 2025 23:15:01 +0200

vdev (1.3.63-1+5gnuinos4) unstable; urgency=medium

  * Add new helper vdev_root_sys_block to determine the device
    where the root partition is mounted
  * Add device-mapper and dm-disk actions to the initrd phase
  * Add new script to initramfs-tools/scripts/local-block that runs
    vgchange in order to activate lvm. Auto-detection with vdev is
    broken.

 -- Aitor <aitor_czr@gnuinos.org>  Sun, 07 Sep 2025 00:32:33 +0200

vdev (1.3.62-1+5gnuinos3) unstable; urgency=medium

  * Reset the console to normal text output after printing in bold
    all input devices found by the helper vdev_wait
  * New upstream version 1.3.62

 -- Aitor <aitor_czr@gnuinos.org>  Wed, 27 Aug 2025 20:35:37 +0200

vdev (1.3.60-1+5gnuinos3) unstable; urgency=medium

  * Bugfix in vdev_blkid() routine of the helper substr.sh: we need to
    skip the slashes and also to add quotes in the 2nd member of the
    'key=value' pairs
  * Minor changes in os/linux.c
  * New upstream version 1.3.60

 -- Aitor <aitor_czr@gnuinos.org>  Sat, 23 Aug 2025 18:19:09 +0200

vdev (1.3.59-1+5gnuinos3) unstable; urgency=medium

  * Redirect to /dev/null error outputs while evaluating the helper
    data gotten from stat_* binaries that lead to weird errors thrown
    by the daemonlet (due to Ilegal numbers)
  * New upstream version 1.3.59

 -- Aitor <aitor_czr@gnuinos.org>  Fri, 22 Aug 2025 11:51:23 +0200

vdev (1.3.58-1+5gnuinos3) unstable; urgency=medium

  * Bugfix in the vdev sysvinit script
  * New upstream version 1.3.58

 -- Aitor <aitor_czr@gnuinos.org>  Thu, 21 Aug 2025 23:57:58 +0200

vdev (1.3.57-1+5gnuinos2) unstable; urgency=medium

  * Add suport for NVMe drives
  * Update stat_ata.c by adding new fields from the IDENTIFY data
  * Add missing variables VDEV_SCSI_WWN and VDEV_SCSI_WWN_WITH_EXTENSION
    to the commonly-used environment variables in the routine
    daemonlet_default_environ() of daemonlet
  * New upstream version 1.3.57

 -- Aitor <aitor_czr@gnuinos.org>  Sat, 16 Aug 2025 13:12:47 +0200

vdev (1.3.56-1+5gnuinos2) unstable; urgency=medium

  * Add a fanotify file descriptor to the enumerated list of FDs to
    poll in os/linux.c, focused primarily to simplify the init script
  * New upstream version 1.3.56

 -- Aitor <aitor_czr@gnuinos.org>  Thu, 14 Aug 2025 19:26:42 +0200

vdev (1.3.55-1+5gnuinos1) unstable; urgency=medium

  * Postpone during the boot process every device related to the acpi
    subsystem, either the device itself or some other parent device
    in the sysfs hierarchy, regardless the device concerned belongs
    to any one of the subsystems in which we are interested. Since
    version 1.3.42 we have been applying the opposite criterion to the
    pci subsystem, but now we take only the acpi subsystem into account
    when it comes to postpone devices in order to speed up the boot
    process. In doing so, we remove the need to distinguish between real
    hardware from virtual machines. And the need to determine the arch
    as well. Moreover, this way is not only more effective, but also
    more rational
  * New upstream version 1.3.55

 -- Aitor <aitor_czr@gnuinos.org>  Wed, 13 Aug 2025 00:58:40 +0200

vdev (1.3.54-1+5gnuinos1) unstable; urgency=medium

  * Fix compiler warning
  * New upstream version 1.3.54

 -- Aitor <aitor_czr@gnuinos.org>  Mon, 11 Aug 2025 09:28:20 +0200

vdev (1.3.53-1+5gnuinos1) unstable; urgency=medium

  * Fix issue in non x86_64 hardware including the whole list of items
    stored in struct sglib_cstr_vector uevents. Same in case we are in
    a virtual machine, regardless the architecture
  * New upstream version 1.3.53

 -- Aitor <aitor_czr@gnuinos.org>  Sun, 10 Aug 2025 10:39:54 +0200

vdev (1.3.52-1+5gnuinos1) unstable; urgency=medium

  * Simplify the runit script
  * Define a tag VDEV_OS_TRACKING_FLAG that allows to keep track of the
    processed coldplug devices. When the last device is processed in
    zzz-udev-compat.act (which takes the value 1 for this flag), the
    aforementioned action sends a SIGTERM signal to the parent, i.e.
    vdevd. TODO: we need to handle the hypothetical case were the last
    device isn't parsed correctly, maybe sending a delayed SIGALRM that
    will terminate the process after a prudent lapse of time.


=== debian/control ===
Source: vdev
Section: admin
Priority: optional
Maintainer: Aitor Cuadrado Zubizarreta <aitor_czr@gnuinos.org>
Uploaders: Jude Nelson <judecn@devuan.org>
Origin: Gnuinos
Standards-Version: 4.3.0
Homepage: http://judecnelson.blogspot.com
X-Python-Version: >= 2.7
XS-Testsuite: autopkgtest
Build-Depends: debhelper (>= 12),
               build-essential,
               pkg-config,
               dh-runit (>= 2.8.8),
               libudev-compat-dev (>= 3.2.15-1~),
               libfuse-dev (>=2.9.3-15),
               libfskit-dev (>=1.0.2),
               libfskit-fuse-dev (>=1.0.2),
               libpstat-dev (>=0.3-1),
               libblkid-dev (>=2.36.1~),
               libinput-dev (>=1.22.1~),
               libevdev-dev (>=1.13.0~),
               squashfs-tools,
               rsync

Package: vdev
Section: admin
Architecture: linux-any
Multi-Arch: foreign
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libudev1-compat (>= 3.2.15-1~),
         libudev-compat-helpers (>= 3.2.15-1~),
         eventfs (>= 0.2-1~),
         util-linux,
         dmidecode,
         sed,
         grep,
         fuse3,
         dash,
         kmod,
         dmsetup,
         iproute2,
Recommends: lvm2
Provides: udev (= 1:3.2.9+devuan4)
Conflicts: udev (<< 1:3.2.9), hal, eudev
Replaces: udev (>= 215),
          bash-completion (<< 1:2.1)
Pre-Depends: build-essential, ${misc:Pre-Depends}
Description: Portable userspace device-file manager.
 Vdev is a new type of device-file manager for *nix that offers per-process
 access controls to device nodes in a portable manner: it offers
 per-process access controls and is portable to most modern UNICES.
 .
 Vdev sticks to a principled design, whereby the filesystem itself is the API,
 the shell is the inter-service glue, and anything is allowed to be a device event source.
 In doing so, vdev offers a simple but powerful model presenting
 per-process views of the host's devices to different programs.
 .
 This package provides the runtime daemon for using vdev as /dev
 manager (the backend device listener), and the actions.

Package: vdevfs
Section: libs
Architecture: linux-any
Multi-Arch: foreign
Recommends: libpstat-util (>= 0.2-1)
Depends: ${shlibs:Depends},
	 ${misc:Depends},
	 libfuse2 (>= 2.9.3-15+deb8u1),
	 libfskit (>= 1.0.2),
	 libpstat1 (>= 0.2-1),
Description: Frontend filesystem and access control.
 Since POSIX permission bits are insufficient for per-process access control,
 vdevfs defines its own notion of an ACL. Now, it's not enough to simply hide devices
 from some processes and not others; vdevfs must be able to equivocate about what it
 knows about devices-namely, the device's permission bits, owner, and group.
 .
 For example, programs in a user's login session should see the device nodes
 that correspond to a user's seat's input devices and video card as owned by
 and accessible to the user, for the duration of the session.

Package: libvdev1
Section: libs
Priority: optional
Architecture: linux-any
Multi-Arch: same
Conflicts: libvdev
Replaces: libvdev
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Vdev core utilities - library (runtime)
 Vdev is a new type of device-file manager for *nix that offers per-process
 access controls to device nodes in a portable manner: it offers
 per-process access controls and is portable to most modern UNICES.
 .
 This package provides the vdev shared library (runtime).

Package: libvdev-dev
Section: libdevel
Priority: optional
Architecture: linux-any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libvdev1 (= ${binary:Version})
Description: Vdev core utilities - library (development files)
 Vdev is a new type of device-file manager for *nix that offers per-process
 access controls to device nodes in a portable manner: it offers
 per-process access controls and is portable to most modern UNICES.
 .
 This package provides the vdev shared library (development files).

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

#export DH_VERBOSE=1

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh $@ --with runit
	
override_dh_auto_install: 
	rsync -a example/actions/*.act debian/vdev/etc/vdev/actions/
	dh_auto_install
	
override_dh_strip:

override_dh_installinit:
	dh_installinit --no-start
	dh_installinit --no-start --init-script=vdev-modprobe.sh

override_dh_link:
	dh_link /etc/init.d/vdev /etc/rcS.d/S02vdev
	dh_link /etc/init.d/vdev-modprobe.sh /etc/rcS.d/S01vdev-modprobe.sh
